/* 
	onload function
*/
jQuery(document).ready(function() {
	jQuery('#image_carousel').jcarousel({
		wrap: 'circular',
		itemVisibleInCallback: {onBeforeAnimation: prog_gallery_carousel_itemVisibleInCallback},
		itemVisibleOutCallback: {onAfterAnimation: prog_gallery_carousel_itemVisibleOutCallback},
		start: prog_gallery_carousel_start + prog_gallery_carousel_itemList.length,
		scroll: 5,
		visible: 5
	});
	prog_gallery_carousel_loadImage(prog_gallery_carousel_start);
});

/* 
	callback functions
*/
function prog_gallery_carousel_itemVisibleInCallback(carousel, item, i, state, evt)
{
	prog_gallery_imagecarousel = carousel;

	// The index() method calculates the index from a
	// given index who is out of the actual item range.
	var idx = carousel.index(i, prog_gallery_carousel_itemList.length);
	carousel.add(i, prog_gallery_carousel_getItemHTML(prog_gallery_carousel_itemList[idx - 1]));
};

/* 
	callback functions
*/
function prog_gallery_carousel_itemVisibleOutCallback(carousel, item, i, state, evt)
{
    carousel.remove(i);
};

/**
	Item html creation helper.
 */
function prog_gallery_carousel_getItemHTML(item)
{
	var html = '<a nohref="#' + prog_gallery_carousel_itemList[item.index].nid + '" onClick="prog_gallery_carousel_start = ' + item.index + ';prog_gallery_carousel_loadImage(jQuery.jcarousel.intval(' + item.index + '))" class="gallery_album_image_thumb_link">';
	//if (prog_gallery_image_view_nothumbs == 1) {
	//	html += '<span id="prog_gallery_carousel_index-' + item.index + '">' + (jQuery.jcarousel.intval(item.index) + 1) + '</span>';
	//} else {
		html += '<div style="height:75px;width:75px;overflow:hidden;">';
		html += '<img src="' + item.url + '" width="75" alt="' + item.title + '" onLoad="if(this.height <= this.width) { this.height=75; this.removeAttribute(\'width\');};" id="prog_gallery_carousel_index-' + item.index + '"/>';
		html += '</div>';
	//}
	html += '</a>';
	return html;
};

/* 
	In a case given index is out of bounds, we normalize it
*/
function prog_gallery_carousel_getnormalindex(index) {
	index = jQuery.jcarousel.intval(index);
	if (index < 0) index = 0;	
	while (index >= prog_gallery_carousel_itemList.length) {
		index = index - prog_gallery_carousel_itemList.length;
	}	
	return index;
}

/* 
	callback functions
*/
function prog_gallery_carousel_loadImage(index) {
	
	index = prog_gallery_carousel_getnormalindex(index);
	
	// scroll carusel so that selected item is in center
	prog_gallery_imagecarousel.scroll(jQuery.jcarousel.intval(index) - 1);

	// load selected image 
	$('.gallery_album_image').attr("src", prog_gallery_base + 'images/loading.gif');
	$('.gallery_album_image').attr("src", prog_gallery_carousel_itemList[index].previewurl);
	$('.gallery_album_image').attr("alt", decodeURIComponent(prog_gallery_carousel_itemList[index].title));
	
	// set # address to link (for history handling)
	//$('a.gallery_album_image_href').attr("href", "#" + prog_gallery_carousel_itemList[prog_gallery_carousel_getnormalindex(index)].nid);

	// load image description
	$('.gallery_album_image_description').html(decodeURIComponent(prog_gallery_carousel_itemList[prog_gallery_carousel_getnormalindex(index)].description));

	// load comments for this image node
	prog_gallery_ajaxcomments_getcomments(prog_gallery_carousel_itemList[index].nid);
	
	// modify "add comment" link-------
	$("a.comment_add").attr('href',	'#' + prog_gallery_carousel_itemList[index].nid);
	$("a.comment_add").unbind('click').click(function() {
			$('div.box').remove();
			$("#comments").prepend('<div class="box"></div>');
			prog_gallery_ajaxcomments_form(prog_gallery_carousel_itemList[index].nid, "new",0,0);
			return false; 
	});
	// or we just remove "add comment" text from viewing the gallery
	//$("li.comment_add").html('');	
	
	// remove default comment add form (also clear comment form div)
	$("div.box").html('');
	
	return true;
}

